#include <string.h>
#include "MDR32F9Qx_port.h"
#include "MDR32F9Qx_rst_clk.h"
#include "MDR32F9Qx_dac.h"
#include "dac.h"
#include "itmr.h"

static unsigned int OutTimer;
#define OutTimerPeriod	10		//1000
	
//------------------------------------------------------------------
void dac_Init(void)
{
	unsigned short port_oe = PORTE->OE;
	MDR_RST_CLK->PER2_CLOCK |= (1ul << 7);
	//    1, 2 - 
	
	
	PORTE->OE = port_oe | (1 << 0) | (1 << 2);	
	
	
	MDR_DAC->DAC1_DATA = 0x0000;		//DAC1
	MDR_DAC->CFG = 0x0004;
	OutTimer = itmr_GetTick();
}

//------------------------------------------------------------------
void dac_SampleOut(unsigned int sample)
{
	MDR_DAC->DAC1_DATA = sample & 0xFFF;
}

//------------------------------------------------------------------
unsigned int dac_Work(void)
{
	static unsigned int sample = 0;
	if(itmr_IsTime(OutTimer, OutTimerPeriod)){		
		dac_SampleOut(sample);	
		sample += 0x32;
		if(sample > 0xFFF) sample = 0;
		OutTimer = itmr_GetTick();
	}
	return sample;
}

//------------------------------------------------------------------
unsigned int dac_GetMaxVal(void)
{
	return 0x00000FFF;
}
