#ifndef __MCP23S18_H__
#define __MCP23S18_H__

#define MCP23S18WRADDR      0x40
#define MCP23S18RDADDR      0x41


//#define __board_ver_1__
#define __board_ver_2__


#define IODIRA_BANK1        0x00
#define IODIRB_BANK1        0x10
#define IPOLA_BANK1         0x01
#define IPOLB_BANK1         0x11
#define GPINTENA_BANK1      0x02
#define GPINTENB_BANK1      0x12
#define DEFVALA_BANK1       0x03
#define DEFVALB_BANK1       0x13
#define INTCONA_BANK1       0x04
#define INTCONB_BANK1       0x14
#define IOCONA_BANK1        0x05
#define IOCONB_BANK1        0x15
#define GPPUA_BANK1         0x06
#define GPPUB_BANK1         0x16
#define INTFA_BANK1         0x07
#define INTFB_BANK1         0x17
#define INTCAPA_BANK1       0x08
#define INTCAPB_BANK1       0x18
#define GPIOA_BANK1         0x09
#define GPIOB_BANK1         0x19
#define OLATA_BANK1         0x0A
#define OLATB_BANK1         0x1A
 
// If you set IOCON.BANK = 1 then all
// the registers are set sequentially
// We will use this method to address
// the registers since it hurts my head less :)
 
#define IODIRA_BANK0        0x00
#define IODIRB_BANK0        0x01
#define IPOLA_BANK0         0x02
#define IPOLB_BANK0         0x03
#define GPINTENA_BANK0      0x04
#define GPINTENB_BANK0      0x05
#define DEFVALA_BANK0       0x06
#define DEFVALB_BANK0       0x07
#define INTCONA_BANK0       0x08
#define INTCONB_BANK0       0x09
#define IOCONA_BANK0        0x0A
#define IOCONB_BANK0        0x0B
#define GPPUA_BANK0         0x0C
#define GPPUB_BANK0         0x0D
#define INTFA_BANK0         0x0E
#define INTFB_BANK0         0x0F
#define INTCAPA_BANK0       0x010
#define INTCAPB_BANK0       0x011
#define GPIOA_BANK0         0x012
#define GPIOB_BANK0         0x013
#define OLATA_BANK0         0x014
#define OLATB_BANK0         0x015
 
#define IODIRn_IO0          (1<<0)
#define IODIRn_IO1          (1<<1)
#define IODIRn_IO2          (1<<2)
#define IODIRn_IO3          (1<<3)
#define IODIRn_IO4          (1<<4)
#define IODIRn_IO5          (1<<5)
#define IODIRn_IO6          (1<<6)
#define IODIRn_IO7          (1<<7)
 
#define IPOLn_IP0           (1<<0)
#define IPOLn_IP1           (1<<1)
#define IPOLn_IP2           (1<<2)
#define IPOLn_IP3           (1<<3)
#define IPOLn_IP4           (1<<4)
#define IPOLn_IP5           (1<<5)
#define IPOLn_IP6           (1<<6)
#define IPOLn_IP7           (1<<7)
 
#define GPINTENn_GPINT0     (1<<0)
#define GPINTENn_GPINT1     (1<<1)
#define GPINTENn_GPINT2     (1<<2)
#define GPINTENn_GPINT3     (1<<3)
#define GPINTENn_GPINT4     (1<<4)
#define GPINTENn_GPINT5     (1<<5)
#define GPINTENn_GPINT6     (1<<6)
#define GPINTENn_GPINT7     (1<<7)
 
#define DEFVALn_DEF0        (1<<0)
#define DEFVALn_DEF1        (1<<1)
#define DEFVALn_DEF2        (1<<2)
#define DEFVALn_DEF3        (1<<3)
#define DEFVALn_DEF4        (1<<4)
#define DEFVALn_DEF5        (1<<5)
#define DEFVALn_DEF6        (1<<6)
#define DEFVALn_DEF7        (1<<7)
 
#define INTCONn_IOC0        (1<<0)
#define INTCONn_IOC1        (1<<1)
#define INTCONn_IOC2        (1<<2)
#define INTCONn_IOC3        (1<<3)
#define INTCONn_IOC4        (1<<4)
#define INTCONn_IOC5        (1<<5)
#define INTCONn_IOC6        (1<<6)
#define INTCONn_IOC7        (1<<7)
 
#define IOCON_INTCC         (1<<0)
#define IOCON_INTPOL        (1<<1)
#define IOCON_ODR           (1<<2)
#define IOCON_RSVD0         (1<<3)
#define IOCON_RSVD1         (1<<4)
#define IOCON_SEQOP         (1<<5)
#define IOCON_MIRROR        (1<<6)
#define IOCON_BANK          (1<<7)
#define IOX_ALLOUTPUT       0x00000000
#define IOX_ALLINPUT        0xFFFFFFFF 
#define IOX_ALLINVERTED     0x00000000
#define IOX_NONEINVERTED    0xFFFFFFFF
//pins
#ifdef __board_ver_1__

#define LCD_LED  2
#define LCD_RES 11
#define LCD_RW  12
#define LCD_RW_in_port	4
#define LCD_E 	14
#define LCD_E_in_port	6
#define SW3 		15 

#endif
#ifdef __board_ver_2__

#define LCD_LED  8
#define LCD_RES 9
#define LCD_RW  10
#define LCD_RW_in_port	2
#define LCD_E 	11
#define LCD_E_in_port	3
// LED0...LED2
#define SW3 		15

#endif
#define Time_LED_Works 30000ul


extern char global_event;

void mcp23s18_Init(void);
//unsigned short mcp23s18_PORTS_Init(void);
//uint16_t mcp23s18_ReadGPIO(void);
unsigned short mcp23s18_ReadGPIO(void);
void mcp23s18_WriteWord(unsigned char addr, unsigned char data);
void mcp23s18_WritePORTS(unsigned short port_state);

void mcp23s18_WriteBit(unsigned char gpio_pin, unsigned char gpio_state);
unsigned short ReadAddress(unsigned char addr);
unsigned char mcp23s18_StartLCD(unsigned char flag, unsigned char crystal, unsigned short gpio_state);

unsigned char SendAndRcvByte(unsigned char byte);
unsigned char mcp23s18_ReadSW3(void);



#endif
