#include "MDR1986BE4.h"
#include "MDR32F9Qx_config.h"
#include "MDR32F9Qx_rst_clk.h"
#include "MDR32F9Qx_adc.h"
#include "MDR32F9Qx_dma.h"
#include "uart.h"
#include "itmr.h"
#include "cb.h"
#include "MDR32F9Qx_port.h"
#define mADC_RES_DATA (0x00000FFFul)

#define CHAN_NUM (2)

#define BUF_SIZE 32
static char SampleBuf[BUF_SIZE];
static TCB SampleCB;
static volatile char StopConvert;
#define CONVERT_PERIOD (1000)
static unsigned int ConvertPeriod;

	DMA_ChannelInitTypeDef DMA_InitStr;
DMA_CtrlDataInitTypeDef DMA_PriCtrlStr;
DMA_CtrlDataInitTypeDef DMA_AltCtrlStr;
uint16_t ADCConvertedValue[10];

static unsigned int ADCState;
enum{
	AS_IDLE,
	AS_START,
	AS_WAIT_RES,
	AS_CNT
};

//--------------------------------------------------------
void adc_Init(void)
{		
//	PORT_InitTypeDef PORT_InitStructure;
	
	
	//RST_CLK_PCLKcmd(RST_CLK_PCLK_ADC, ENABLE);	
	// ADC PORTS
	/*PORT_InitStructure.PORT_OE = PORT_OE_IN;	
	PORT_InitStructure.PORT_PULL_UP = PORT_PULL_UP_OFF;
  PORT_InitStructure.PORT_PULL_DOWN = PORT_PULL_DOWN_OFF;
	
	PORT_InitStructure.PORT_FUNC = PORT_FUNC_PORT;
	PORT_InitStructure.PORT_MODE = PORT_MODE_DIGITAL;
	PORT_InitStructure.PORT_SPEED = PORT_SPEED_MAXFAST;
	
	PORT_InitStructure.PORT_Pin = (PORT_Pin_6|PORT_Pin_7);
	PORT_Init(MDR_PORTB, &PORT_InitStructure);
	*/
	


  RST_CLK_PCLKcmd((RST_CLK_PCLK_RST_CLK | RST_CLK_PCLK_DMA | RST_CLK_PCLK_ADC),ENABLE);
  
  DMA_DeInit();
  DMA_StructInit(&DMA_InitStr);
  
  DMA_PriCtrlStr.DMA_SourceBaseAddr = (uint32_t)(&(MDR_ADC->ADC1_RESULT));
  DMA_PriCtrlStr.DMA_DestBaseAddr = (uint32_t)ADCConvertedValue;
  DMA_PriCtrlStr.DMA_SourceIncSize = DMA_SourceIncNo;
  DMA_PriCtrlStr.DMA_DestIncSize = DMA_DestIncHalfword;
  DMA_PriCtrlStr.DMA_MemoryDataSize = DMA_MemoryDataSize_HalfWord;
  DMA_PriCtrlStr.DMA_Mode = DMA_Mode_PingPong;
  DMA_PriCtrlStr.DMA_CycleSize = 10;
  DMA_PriCtrlStr.DMA_NumContinuous = DMA_Transfers_1;
  DMA_PriCtrlStr.DMA_SourceProtCtrl = DMA_SourcePrivileged;
  DMA_PriCtrlStr.DMA_DestProtCtrl = DMA_DestPrivileged;

  
  DMA_AltCtrlStr.DMA_SourceBaseAddr = (uint32_t)(&(MDR_ADC->ADC1_RESULT));
  DMA_AltCtrlStr.DMA_DestBaseAddr   = (uint32_t)ADCConvertedValue;
  DMA_AltCtrlStr.DMA_SourceIncSize = DMA_SourceIncNo;
  DMA_AltCtrlStr.DMA_DestIncSize = DMA_DestIncHalfword;
  DMA_AltCtrlStr.DMA_MemoryDataSize = DMA_MemoryDataSize_HalfWord;
  DMA_AltCtrlStr.DMA_Mode = DMA_Mode_PingPong;
  DMA_AltCtrlStr.DMA_CycleSize = 10;
  DMA_AltCtrlStr.DMA_NumContinuous = DMA_Transfers_1;
  DMA_AltCtrlStr.DMA_SourceProtCtrl = DMA_SourcePrivileged;
  DMA_AltCtrlStr.DMA_DestProtCtrl = DMA_DestPrivileged;

 
  DMA_InitStr.DMA_PriCtrlData = &DMA_PriCtrlStr;
  DMA_InitStr.DMA_AltCtrlData = &DMA_AltCtrlStr;
  DMA_InitStr.DMA_Priority = DMA_Priority_Default;
  DMA_InitStr.DMA_UseBurst = DMA_BurstClear;
  DMA_InitStr.DMA_SelectDataStructure = DMA_CTRL_DATA_PRIMARY;

  DMA_Init(DMA_Channel_ADC, &DMA_InitStr);

  
  MDR_DMA->CHNL_REQ_MASK_CLR = (1<<DMA_Channel_ADC);
  MDR_DMA->CHNL_USEBURST_CLR = (1<<DMA_Channel_ADC);

  DMA_Cmd(DMA_Channel_ADC, ENABLE);

  

	
	
		ADC_DeInit();
	//MDR_RST_CLK->PER2_CLOCK |= (1ul << 8);	// 7 for DAC
	MDR_RST_CLK->ADC_MCO_CLOCK = 0x00002FF0;	//0x00002F20
	//ADC->ADC1_CFG |= 0xFEC2F025;
	MDR_ADC->ADC1_CFG |= 0xFEC2500D | (7 << 4);	// 0 channel  0xFEC2500D
	MDR_ADC->ADC1_STATUS = 2;		
	cb_Init(&SampleCB, SampleBuf, BUF_SIZE);	
	ConvertPeriod = itmr_GetTick();
	MDR_ADC->ADC1_CFG |= 1;
	ADC1_ITConfig((ADCx_IT_END_OF_CONVERSION  | ADCx_IT_OUT_OF_RANGE), DISABLE);
	/* Enable DMA IRQ */
  NVIC_EnableIRQ(DMA_IRQn);
}

//--------------------------------------------------------
void adc_IRQ(void)
{				
	unsigned int tmp = MDR_ADC->ADC1_RESULT;	
	tmp &= mADC_RES_DATA;		
	cb_AddByte(&SampleCB, (char)(tmp & 0xff));	
	cb_AddByte(&SampleCB, (char)((tmp >> 8) & 0xff));		
	StopConvert = 1;
	
}

//--------------------------------------------------------
static char IsSample(void)
{
	unsigned int res;
///	NVIC_DisableIRQ(ADC_IRQn);
	res = cb_GetByteCnt(&SampleCB);	
//	NVIC_EnableIRQ(ADC_IRQn);	
	return (res > 3) ? 1 : 0;
}

//--------------------------------------------------------
static unsigned int GetSample(void)
{	
	char byte[3];
//	NVIC_DisableIRQ(ADC_IRQn);
	cb_GetByte(&SampleCB, &byte[0]);
	cb_GetByte(&SampleCB, &byte[1]);
	//cb_GetByte(&SampleCB, &byte[2]);	
//	NVIC_EnableIRQ(ADC_IRQn);	
	return byte[0] | (byte[1] << 8);
}

//--------------------------------------------------------
char adc_GetSample(unsigned int* sample)
{
	if(IsSample()){
		*sample = GetSample();
		return 1;
	}
	else
		return 0;
}

//--------------------------------------------------------
static void adc_StartConvert(void)
{
	 MDR_ADC->ADC1_CFG |= (1 << 1);
}
	 
//--------------------------------------------------------
char adc_Work(unsigned int* psample)
{		
	#define CONV_CNT	100
	static unsigned int conv_cnt;
	static unsigned int sample, sum;
	switch(ADCState){
		case AS_IDLE:
			if(itmr_IsTime(ConvertPeriod, CONVERT_PERIOD)){
				ADCState = AS_START;
				ConvertPeriod = itmr_GetTick();
				conv_cnt = CONV_CNT;				
				sum = 0;
			}
			break;
		case AS_START:
			adc_StartConvert();
			StopConvert = 0;	
			conv_cnt--;
			ADCState = AS_WAIT_RES;		
			break;
		case AS_WAIT_RES:
			if(StopConvert){
				adc_GetSample(&sample);
				sum += sample;
				if(conv_cnt)
					ADCState = AS_START;
				else{
					ADCState = AS_IDLE;
					*psample = sum / CONV_CNT;
					return 1;
				}
			}
			break;
		default:
			break;
	}
	return 0;
}

unsigned int adc_GetMaxVal(void)
{
	return 0x00000FFF;
}
unsigned short adc_result(void)
{
	unsigned int result;
	unsigned short result1;
		NVIC_EnableIRQ(DMA_IRQn);
	result = (unsigned int) (12*ADCConvertedValue[2]/14);
	result = (unsigned int) (1174*result/1277);
	result1 = result & 0xFFFF;
	return result1;
}
/*unsigned int adc_test(void)
{unsigned short result1;
	char buffer[32];
		result1 = adc_result();
		NVIC_EnableIRQ(DMA_IRQn);
		//result = MDR_ADC->ADC1_RESULT;
		//result1 = (char) result;
	sprintf(buffer, "%d", result1);		// 1 and 2
		uart_SendBuf(buffer,10);
		uart_SendStr(" \r\n>");
		itmr_Delay(100);
}*/


