#include <string.h>
#include "MDR32F9Qx_port.h"
#include "MDR32F9Qx_timer.h"
#include "MDR32F9Qx_rst_clk.h"
//#include "MDR32F9Qx_dac.h"
#include "dac.h"
#include "itmr.h"
#include "timcap.h"
static unsigned int OutTimer;
#define OutTimerPeriod	10		//1000
#define POS 0x32
#define NEG 0
static unsigned int pos;
static unsigned int sample = 0;
static char flag = 0;

//------------------------------------------------------------------
void dac_Init(void)
{
	
	PORT_InitTypeDef PORT_InitStructure;
	
	
	RST_CLK_PCLKcmd(RST_CLK_PCLK_PORTB , ENABLE);	
	
	
	PORT_InitStructure.PORT_OE = PORT_OE_OUT;	
	PORT_InitStructure.PORT_PULL_UP = PORT_PULL_UP_OFF;
  PORT_InitStructure.PORT_PULL_DOWN = PORT_PULL_DOWN_OFF;
	
	PORT_InitStructure.PORT_FUNC = PORT_FUNC_PORT;
	PORT_InitStructure.PORT_MODE = PORT_MODE_DIGITAL;
	PORT_InitStructure.PORT_SPEED = PORT_SPEED_FAST;
	
	PORT_InitStructure.PORT_Pin = (PORT_Pin_11 | PORT_Pin_13);
	PORT_Init(MDR_PORTB, &PORT_InitStructure);
	
	timcap2_Init();
	//OutTimer = itmr_GetTick();
}
void dac_DeInit(void)
{
	timcap2_DeInit();
	sample = 0;
}
//------------------------------------------------------------------
void dac_SampleOut(unsigned int sample)
{
	MDR_DAC->DAC1_DATA = sample & 0xFFF;
}

//------------------------------------------------------------------
unsigned int dac_Work(void)
{
/*
	if(itmr_IsTime(OutTimer, OutTimerPeriod)){		
		dac_SampleOut(sample);	
		sample += 0x32;
		if(sample > 0xFFF) sample = 0;
		OutTimer = itmr_GetTick();
	}*/
if(itmr_IsTime(OutTimer, OutTimerPeriod)){		
		//dac_SampleOut(sample);	
		sample ++;
		if(sample > 100) sample = 0;
		OutTimer = itmr_GetTick();
	}	
	return sample;

}
void dac_PWM(void)
{ pos++;
	
	if (flag == 0)
	{PORT_WriteBit(MDR_PORTB, PORT_Pin_13, Bit_SET);			
		PORT_WriteBit(MDR_PORTB, PORT_Pin_11, Bit_SET);
		
		if (pos > sample)
		{
			flag = 1;
			pos = 0;
		}	
	}
	else {
		PORT_WriteBit(MDR_PORTB, PORT_Pin_13, Bit_RESET);			
		PORT_WriteBit(MDR_PORTB, PORT_Pin_11, Bit_RESET);
		
		if (pos == (101))
	{	
		flag = 0;
		pos = 0;
	}
	}
	
}
//------------------------------------------------------------------
unsigned int dac_GetMaxVal(void)
{
	return 0x00000FFF;
}
