#include "misc.h"

//   
uidiv_t uidiv(unsigned int dividend, unsigned int divisor)
{
	uidiv_t temp;
	
	temp.q = dividend / divisor;
	temp.r = dividend - divisor * temp.q;

	return temp; 
}

//    
// num -   
// str -  -  
// max_cnt -     
//   -    
unsigned int uint2text(unsigned int val, unsigned char* str, unsigned int max_cnt)
{
	unsigned int cnt = 0;
	unsigned char* bp = str + max_cnt;

	if (!max_cnt)  return 0; 

	if (val) {
		uidiv_t d;
		d.q = val;

		while (d.q) {
			d = uidiv(d.q, 10);
			*(--bp) = (unsigned char)d.r + '0';
			cnt++;

			if (--max_cnt == 0) break;
    	}
  	}
	else {
    	*(--bp) = '0';
    	cnt++;
  	}

  	return cnt;
}

void delay(unsigned int delay)
{
	while(delay--);
}

//---------------------------------------------------------------------------------------------
unsigned int CalcSum(void* buf, unsigned int size)
{
	unsigned int sum = 0;
	
	while(size > 1){
		sum += *((unsigned short*)buf)++;	
		size -= sizeof(unsigned short);
	}	
	if(size > 0)
		sum += *(unsigned char*)buf;

	return sum;		
}

//---------------------------------------------------------------------------------------------
unsigned short CalcHeaderCS(void* buf, unsigned int size)
{
	unsigned int cs;	
	cs = CalcSum(buf, size);			

	while(cs >> 16)
		cs = (cs & 0xFFFF) + (cs >> 16);

	return (unsigned short)(~cs);
}
