#include "MDR32F9Qx_port.h"
#include "MDR32F9Qx_rst_clk.h"

#include "stdio.h"
#include <string.h>

#include "disp.h"
#include "misc.h"
#include "itmr.h"

#include "mouse.h"

#define __DEBUG_MOUSE
#ifdef __DEBUG_MOUSE	
	#include "uart.h"
#include "led.h"	
#endif

#define CMD_RESET					0xFF
#define CMD_STREAM_MODE		0xEA
#define CMD_ENABLE   			0xF4
#define KB_DATA_SET				PORT_WriteBit(MDR_PORTA, PORT_Pin_2, Bit_SET)
#define KB_DATA_RESET			PORT_WriteBit(MDR_PORTA, PORT_Pin_2, Bit_RESET)
#define KB_CLK_SET				PORT_WriteBit(MDR_PORTA, PORT_Pin_0, Bit_SET)
#define KB_CLK_RESET			PORT_WriteBit(MDR_PORTA, PORT_Pin_0, Bit_RESET)

static PORT_InitTypeDef PORT_InitStructure;

static char LastXPos, LastYPos;
static int CurXPos, CurYPos;
static int CurXChPos, CurYChPos;
//static unsigned short i = 0;
static char mouse_data_first, mouse_data_X, mouse_data_Y;
static unsigned char bit_pos = 0;
static int ch = 0, mouse_data;

typedef bool (*TRcvCmdAnswer)(char* answ, unsigned char answ_size);


void mouse_Init(void)
{		RST_CLK_PCLKcmd(RST_CLK_PCLK_RST_CLK | RST_CLK_PCLK_PORTA, ENABLE);
	PORT_InitStructure.PORT_OE = PORT_OE_OUT;	
	PORT_InitStructure.PORT_MODE = PORT_MODE_DIGITAL;
	PORT_InitStructure.PORT_SPEED = PORT_SPEED_MAXFAST;	
	PORT_InitStructure.PORT_FUNC = PORT_FUNC_PORT;
	PORT_InitStructure.PORT_PULL_UP = PORT_PULL_UP_OFF;
	PORT_InitStructure.PORT_PULL_DOWN = PORT_PULL_DOWN_OFF;
	PORT_InitStructure.PORT_Pin = PORT_Pin_0 | PORT_Pin_2;
		PORT_Init(MDR_PORTA, &PORT_InitStructure);
	
	PORT_InitStructure.PORT_Pin = PORT_Pin_0 | PORT_Pin_2;	
	PORT_Init(MDR_PORTA, &PORT_InitStructure);	
	
	CurXPos = disp_XSize() >> 1;
	CurYPos = disp_YSize() >> 1;
	
}

//    
void send_cmd(unsigned char cmd)
{
	static unsigned char bit_pos = 0, parity = 1;
//	static short ch = 0;

	unsigned char Cmd;
	
				bit_pos = 0;
				Cmd = cmd;
		while(bit_pos < 8){	
				
			
				if((Cmd >> bit_pos) & 0x01){
					PORT_WriteBit(MDR_PORTA, PORT_Pin_2, Bit_SET);
							parity ^= 1;
					//delay(DELAY_10US);
				}
				else{
					PORT_WriteBit(MDR_PORTA, PORT_Pin_2, Bit_RESET);					
						parity ^= 0;
					//delay(DELAY_10US);
				}			
				while(PORT_ReadInputDataBit(MDR_PORTA, PORT_Pin_0) == Bit_SET) {;}	
			while(PORT_ReadInputDataBit(MDR_PORTA, PORT_Pin_0) == Bit_RESET) {;}
				
				bit_pos++;										
			
		}
				
			
				if(parity){
					PORT_WriteBit(MDR_PORTA, PORT_Pin_2, Bit_SET);	
									
				}
				else{
					PORT_WriteBit(MDR_PORTA, PORT_Pin_2, Bit_RESET);											
					
				}
			
				parity = 1;
		while (PORT_ReadInputDataBit(MDR_PORTA, PORT_Pin_0) == Bit_SET){;}				
		while (PORT_ReadInputDataBit(MDR_PORTA, PORT_Pin_0) == Bit_RESET){;}
				
			
					PORT_InitStructure.PORT_OE = PORT_OE_IN;	
				PORT_InitStructure.PORT_MODE = PORT_MODE_DIGITAL;
				PORT_InitStructure.PORT_SPEED = PORT_SPEED_MAXFAST;	
				PORT_InitStructure.PORT_PULL_UP = PORT_PULL_UP_OFF;
				PORT_InitStructure.PORT_PULL_DOWN = PORT_PULL_DOWN_OFF;
				
				PORT_InitStructure.PORT_FUNC = PORT_FUNC_PORT;	
				PORT_InitStructure.PORT_Pin = PORT_Pin_0 | PORT_Pin_2;	
				PORT_Init(MDR_PORTA, &PORT_InitStructure);	
			//timcap1_Init();
}
/*
unsigned char mouse_read(void)
{
	unsigned char data = 0, mask = 0x01;
	int i =0;
	
	TIM1_LOCK();
	PORT_InitStructure.PORT_OE = PORT_OE_OUT;	
	PORT_InitStructure.PORT_MODE = PORT_MODE_DIGITAL;
	PORT_InitStructure.PORT_SPEED = PORT_SPEED_MAXFAST;	
	PORT_InitStructure.PORT_FUNC = PORT_FUNC_PORT;
	PORT_InitStructure.PORT_PULL_UP = PORT_PULL_UP_OFF;
	PORT_InitStructure.PORT_PULL_DOWN = PORT_PULL_DOWN_OFF;
	PORT_InitStructure.PORT_Pin = PORT_Pin_0 | PORT_Pin_2;
		PORT_Init(MDR_PORTA, &PORT_InitStructure);
	PORT_WriteBit(MDR_PORTA, PORT_Pin_0 | PORT_Pin_2, Bit_SET);	
	//delay(DELAY_50US);
	
		PORT_InitStructure.PORT_OE = PORT_OE_IN;	
				PORT_InitStructure.PORT_MODE = PORT_MODE_DIGITAL;
				PORT_InitStructure.PORT_SPEED = PORT_SPEED_MAXFAST;	
				PORT_InitStructure.PORT_PULL_UP = PORT_PULL_UP_OFF;
				PORT_InitStructure.PORT_PULL_DOWN = PORT_PULL_DOWN_OFF;
				
				PORT_InitStructure.PORT_FUNC = PORT_FUNC_PORT;	
				PORT_InitStructure.PORT_Pin = PORT_Pin_0 | PORT_Pin_2;	
				PORT_Init(MDR_PORTA, &PORT_InitStructure);	
	itmr_Delay(10);
		PORT_InitStructure.PORT_OE = PORT_OE_OUT;	
	PORT_InitStructure.PORT_MODE = PORT_MODE_DIGITAL;
	PORT_InitStructure.PORT_SPEED = PORT_SPEED_MAXFAST;	
	PORT_InitStructure.PORT_FUNC = PORT_FUNC_PORT;
	PORT_InitStructure.PORT_PULL_UP = PORT_PULL_UP_OFF;
	PORT_InitStructure.PORT_PULL_DOWN = PORT_PULL_DOWN_OFF;
	PORT_InitStructure.PORT_Pin = PORT_Pin_0;
		PORT_Init(MDR_PORTA, &PORT_InitStructure);
				
		PORT_WriteBit(MDR_PORTA, PORT_Pin_0, Bit_RESET);

	
		
return data;				
	
	
}*/
bool mouse_SendRequest(unsigned char cmd)
{		unsigned char i = 0;	
	
	//  
	TIM1_LOCK();
	//     
	
	PORT_InitStructure.PORT_OE = PORT_OE_OUT;	
	PORT_InitStructure.PORT_MODE = PORT_MODE_DIGITAL;
	PORT_InitStructure.PORT_SPEED = PORT_SPEED_MAXFAST;	
	PORT_InitStructure.PORT_FUNC = PORT_FUNC_PORT;
	PORT_InitStructure.PORT_PULL_UP = PORT_PULL_UP_OFF;
	PORT_InitStructure.PORT_PULL_DOWN = PORT_PULL_DOWN_OFF;
	PORT_InitStructure.PORT_Pin = PORT_Pin_0 | PORT_Pin_2;
		PORT_Init(MDR_PORTA, &PORT_InitStructure);
		
	PORT_WriteBit(MDR_PORTA, PORT_Pin_0 | PORT_Pin_2, Bit_SET);	
		delay(DELAY_100US);
	//     "0"
	PORT_WriteBit(MDR_PORTA, PORT_Pin_2, Bit_RESET);	
	delay(DELAY_100US);
	//itmr_Delay(100);
	//     "0"
	PORT_WriteBit(MDR_PORTA, PORT_Pin_0, Bit_RESET);	
	delay(DELAY_100US);
	//     "1" -       
	//PORT_WriteBit(MDR_PORTA, PORT_Pin_0, Bit_SET);	
	delay(DELAY_100US);
	//      
	
				PORT_InitStructure.PORT_OE = PORT_OE_IN;	
				PORT_InitStructure.PORT_MODE = PORT_MODE_DIGITAL;
				PORT_InitStructure.PORT_SPEED = PORT_SPEED_MAXFAST;	
				PORT_InitStructure.PORT_PULL_UP = PORT_PULL_UP_OFF;
				PORT_InitStructure.PORT_PULL_DOWN = PORT_PULL_DOWN_OFF;
				
				PORT_InitStructure.PORT_FUNC = PORT_FUNC_PORT;	
				PORT_InitStructure.PORT_Pin = PORT_Pin_0;	
				PORT_Init(MDR_PORTA, &PORT_InitStructure);	
	while ((PORT_ReadInputDataBit(MDR_PORTA, PORT_Pin_0) == Bit_SET) && ( i < 200)){ i++;}
	if (i < 200) {
	send_cmd(cmd);
		i = 0;
		return true;
	}
	else return false;
	//timcap1_Init();	
	
}


void mouse_IRQProc(void)
{	
	
	if((PORT_ReadInputData(MDR_PORTA) & PORT_Pin_2) && (bit_pos < 32)){
				ch |= 1 << bit_pos;
	}
			bit_pos++;				
			if((bit_pos == 32) && ((ch & 0xE) == (ch & 0xF)) && (((ch >> 8) & 0x7) == ((ch >> 8) & 0xF))){											
				bit_pos = 0;	
						mouse_data = ch;
				ch >>= 1;
			//	ch &= 0x00FF;		
			
				mouse_data_first =(char) (ch & 0xFF);
				ch >>= 11;
				mouse_data_X = (char) (ch & 0xFF);
				ch >>= 11;
				mouse_data_Y = (char) (ch & 0xFF);
		
				ch = 0;				
				
			}
			else if (((ch & 0xE) != (ch & 0xF)) || (((ch >> 8) & 0x7) != ((ch >> 8) & 0xF)))
				{ bit_pos = 0;
						ch = 0;
					delay(DELAY_100US);
				}
			
}


char mouse_GetState(unsigned int* state)
{
	if (mouse_data_first !=0) {
			return 1;
	}
	else return 0;
}

TMousePos mouse_GetPos(void)
{
	TMousePos curpos;
				
	unsigned char mstat, MsX, MsY;
	if (mouse_data_first != 0) {
	mstat = mouse_data_first;
	MsX = mouse_data_X;
	MsY = mouse_data_Y;
	}
	if (mstat & 0x01) {led_Toggle(6); 
	curpos.L = 1;			
	}
	else  curpos.L = 0;
	if (mstat & 0x02) curpos.R = 1;
	else curpos.R = 0;
	if (mstat & 0x04) curpos.M = 1;
	else curpos.M = 0;
	if (mouse_data_first !=0) {
		timcap1_DeInit();
		mouse_data_first = 0;
		mouse_data_X = 0;
		mouse_data_Y = 0;
		//itmr_Delay(10);
	
		
			if(LastXPos != MsX){
				LastXPos = MsX;
				if(LastXPos > 127)
					CurXPos += (int)LastXPos - 256;
				else
					CurXPos += LastXPos;
				if(CurXPos < 0) CurXPos = 0; else 
				if(CurXPos > disp_XPixel()) CurXPos = disp_XPixel();											
			}
		
			
		
		if(LastYPos != MsY){
				LastYPos = MsY;
				if(LastYPos > 127)
					CurYPos += (int)LastYPos - 256;
				else
					CurYPos += LastYPos;
				if(CurYPos < 0) CurYPos = 0; else 
				if(CurYPos > disp_YPixel()) CurYPos = disp_YPixel();										
			}					

			disp_CharPosition(CurXPos, CurYPos, &CurXChPos, &CurYChPos);
			curpos.x = CurXChPos;
			curpos.y = CurYChPos;
			
			timcap1_Init();				
		}
	
	return curpos;
}
bool mouse_Initialize(void)
{	
	bool success = 0;
	mouse_Init();
	success = mouse_SendRequest(0xFF);		//Resets mouse
	
	itmr_Delay(100);
	success = mouse_SendRequest(0xF4);		// enable data reporting
	itmr_Delay(100);
	success = mouse_SendRequest(0xF3);		// Sets sample rate
	itmr_Delay(100);
	success = mouse_SendRequest(0x0A);		// sample rate = 10 samples/sec
	itmr_Delay(100);
	success = mouse_SendRequest(0xE8);		// sets resolution
	itmr_Delay(100);
	success = mouse_SendRequest(0x01);		// resolution = 1 count/mm
	itmr_Delay(100);
	timcap1_Init();	
	return success;		// if true - initialize successed
}
unsigned int mouse_loop(void)
{unsigned int mstat;
	 char buffer[32];
	mstat = mouse_data;
	
	
	sprintf(buffer, "%x", mstat);
		 uart_SendBuf(buffer,6);
		 uart_SendStr("\r\n>");
	
	//sprintf(buffer, "%x", mouse_data_first);
	//	 uart_SendBuf(buffer,6);
		uart_SendByte(mouse_data_first);
		uart_SendStr("\r\n>");
	
	//sprintf(buffer, "%x", mouse_data_X);
	//	 uart_SendBuf(buffer,6);
	uart_SendByte(mouse_data_X);	 
	uart_SendStr("\r\n>");
	
	//sprintf(buffer, "%x", mouse_data_Y);
	//	 uart_SendBuf(buffer,6);
		 uart_SendByte(mouse_data_Y);
		 uart_SendStr("\r\n>");
	itmr_Delay(500);
	
	/*if (mstat & 0x01) { led_Toggle(6); }
	if (mouse_data_first !=0) {
		timcap1_DeInit();
		mouse_data_first = 0;
		mouse_data_X = 0;
		mouse_data_Y = 0;
		itmr_Delay(10);
		timcap1_Init();
	}	*/
	//Mode = MODE_ACK;
	//data = mouse_read();
	
	//checkpoint 7
	//itmr_Delay(500);
	return mstat;
}
