#include <string.h>
#include <stdio.h>
#include "itmr.h"
#include "console.h"
#include "wnds.h"
#include "disp.h"
#include "keyboard.h"
#include "mouse.h"
#include "button.h"
#include "main.h"


//#define __DEBUG_MOUSE_WND__
#ifdef __DEBUG_MOUSE_WND__
#include "uart.h"
#define DbgSize	128
static char Dbg[DbgSize];
#endif

static TMousePos MousePos;

static bool EventProc(unsigned int code, unsigned int data);

static TWnd Wnd = { WID_MOUSE, 0, EventProc, 0 };
	 bool mouse_init_status;

static bool EventProc(unsigned int code, unsigned int data)
{	
	TMousePos mouse_pos;
//	unsigned int mouse_state;
	
	switch (code) {
    case WE_DRAW:
      if (data == 0) {
				disp_ShowStr(0, 0, " ");
      }
      break;   
		case WE_BUTTON:
			switch(data){
				case LEFT:					
					wnd_choose = 3;
					console_CloseWnd(0);
					break;
				default:
					break;
			}
			break;
					
		case WE_KEYS:		
			switch(data){
				case KEY_ESC:
					wnd_choose = 3;
					console_CloseWnd(0);
					break;				
			}
			break;				
		case WE_MOUSE:			
				mouse_pos = mouse_GetPos();								
			if(memcmp(&MousePos, &mouse_pos, sizeof(TMousePos))){
				//if (sizeof(&MousePos) > sizeof(&mouse_pos)){
				disp_ShowChar(MousePos.x, disp_YSize() - MousePos.y + 1, ' ');
				MousePos = mouse_pos;						
				#ifdef __DEBUG_MOUSE_WND__
				sprintf(Dbg, "[X] %d : [Y] %d \r\n", mouse_pos.x, mouse_pos.y);
				uart_SendStr(Dbg);
				#endif
				disp_ShowChar(mouse_pos.x, disp_YSize() - mouse_pos.y + 1, 'X');			
			}
			if(mouse_pos.L == 1)
				disp_ShowChar(mouse_pos.x, disp_YSize() - mouse_pos.y + 1, 'L');				
			else
			if(mouse_pos.R == 1)
				disp_ShowChar(mouse_pos.x, disp_YSize() - mouse_pos.y + 1, 'R');
			else				
			if(mouse_pos.M == 1)
				disp_ShowChar(mouse_pos.x, disp_YSize() - mouse_pos.y + 1, 'M');
			else
				disp_ShowChar(mouse_pos.x, disp_YSize() - mouse_pos.y + 1, 'X');			
			break;
		/*case WE_CYCLE:
			mouse_GetState(&mouse_state);
			mouse_pos = mouse_GetPos();								
		break;*/
  }

  return true;
}

void wnd_Mouse(void)
{ 
	itmr_Delay(100);
	mouse_init_status = mouse_Initialize();
	if (!mouse_init_status) {
		console_OpenWnd(&Wnd);
		
		disp_ShowStr(0, 0, "Error!                ");
		disp_ShowStr(0, 1, "Mouse is undefined!");
		disp_ShowStr(0, 2, "1. Check connection");
		disp_ShowStr(0, 3, "2. Try to change SA2");
		disp_ShowStr(0, 4, "position");
		delay(DELAY_2SEC);
		console_CloseWnd(0);				
		
	}
	else {
	console_OpenWnd(&Wnd); 
	wnd_choose = 2;}
  
}
