#include <string.h>
#include <stdio.h>
#include "itmr.h"
#include "console.h"
#include "wnds.h"
#include "disp.h"
#include "keyboard.h"
#include "button.h"
#include "rs485.h"

static unsigned int ShowTimer;
static bool EventProc(unsigned int code, unsigned int data);

static TWnd Wnd = { WID_RS485_TEST, 0, EventProc, 0 };

static bool EventProc(unsigned int code, unsigned int data)
{			
	char write_res, read_res;
	switch (code) {
    case WE_DRAW:
      if (data == 0) {				
				disp_ShowStr(0, 0, " ");
				disp_ShowStr(0, 1, " .5");
				disp_ShowStr(0, 2, "Tx: ");
				disp_ShowStr(0, 3, ". ");
				disp_ShowStr(0, 4, "Rx: ");				
      }
      break;   
		case WE_BUTTON:
			switch(data){
				case LEFT:
					rs485_DeInit();
					console_CloseWnd(0);
					break;
				default:
					break;
			}
			break;
					
		case WE_KEYS:		
			switch(data){
				case KEY_ESC:
					rs485_DeInit();
					console_CloseWnd(0);
					break;				
			}
			break;				
		case WE_CYCLE:
			rs485_TestWork(&write_res, &read_res);
			if(itmr_IsTime(ShowTimer, 100ul)){
				disp_ShowStr(4, 2, write_res ? " 1" : " 0");	
				disp_ShowStr(4, 4, read_res ? " 1" : " 0");	
				ShowTimer = itmr_GetTick();
			}
			break;					
  }

  return true;
}

void wnd_RS485Test(void)
{ rs485_Init();
  ShowTimer = itmr_GetTick();
	console_OpenWnd(&Wnd);
}
